// 15.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "fifteen.h"
#include "records.h"

#define MAX_LOADSTRING	100
#define NBUTTONS		5
#define IDB_NEW			3
#define IDB_RESULTS		4
#define IDB_ABOUT		0
#define IDB_MINIMIZE	2
#define IDB_CLOSE		1

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
void				RedrawMove(HWND,int,int,int,int);
void				CenterWindow(HWND);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Results(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	Top(HWND, UINT, WPARAM, LPARAM);
void	AboutClick(HWND);
void	ResultsClick(HWND);
void	CloseClick(HWND);
void	MinimizeClick(HWND);
void	NewClick(HWND);
void	Victory(HWND);

typedef void(*aProc)(HWND) ;
typedef struct _ButtonData
{
	int left,right,top,bottom;
	HANDLE normImg,overImg;
	aProc onClick;
} ButtonData;

//more globals
BOOL		started=FALSE;
int			prevOver=-1;
int			prevDir=-1;
int			eltime,result;
int			DragStartX,DragStartY;
BOOL		dragged=FALSE;
TCHAR		szLastName[30];
TCHAR		szRecordsFile[MAX_PATH];

ButtonData	Buttons[NBUTTONS];
int			cursors[4]={IDC_DOWN,IDC_LEFT,IDC_UP,IDC_RIGHT};
CFifteen	game;
CRecords	records;
HANDLE		BgImage,NumbersImage;
//0 doesn't count!!!!!!!!
int			numbers[16][2]={{150,150},{0,0},{50,0},{100,0},{150,0},
							{0,50},{50,50},{100,50},{150,50},	
							{0,100},{50,100},{100,100},{150,100},
							{0,150},{50,150},{100,150}};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	TCHAR szBuf[MAX_PATH];
	int len;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MY15, szWindowClass, MAX_LOADSTRING);
	len=GetModuleFileName(NULL,szBuf,MAX_PATH);
	for(int i=len-1;i>0;i--)
		if(szBuf[i]=='\\')
		{
			strncpy(szRecordsFile,szBuf,i+1);
			szBuf[i+1]='\0';
		};
	strcat(szRecordsFile,"records.dat");

	records.Load(szRecordsFile);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
	}
	records.Save(szRecordsFile);
	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_MY15);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)NULL;//IDC_MY15;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= (HICON)NULL;//LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
   RECT rt;

   hInst = hInstance; // Store instance handle in our global variable
   GetWindowRect(GetDesktopWindow(),&rt);

   hWnd = CreateWindowEx(0,szWindowClass, "Fifteen",//WS_EX_DLGMODALFRAME|WS_EX_RIGHTSCROLLBAR|WS_EX_CONTROLPARENT|WS_EX_LEFT|WS_EX_LTRREADING
	   WS_CLIPSIBLINGS|WS_POPUP|WS_SYSMENU,
      (rt.right-220)/2,(rt.bottom-260)/2, 220, 260, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc,hbmpdc;
	int xPos,yPos,i,j,overIndex,nVirtKey,Dir;
	TCHAR szTime[100];

	switch (message) 
	{
		case WM_CREATE:
			Buttons[IDB_RESULTS].left = 58;
			Buttons[IDB_RESULTS].top = 11;
			Buttons[IDB_RESULTS].right = 98;
			Buttons[IDB_RESULTS].bottom = 28;
			Buttons[IDB_RESULTS].normImg = LoadImage(hInst,
				(LPCTSTR)IDB_RESULTSN,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_RESULTS].overImg = LoadImage(hInst,
				(LPCTSTR)IDB_RESULTSO,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_RESULTS].onClick = ResultsClick;
			Buttons[IDB_ABOUT].left = 100;
			Buttons[IDB_ABOUT].top = 11;
			Buttons[IDB_ABOUT].right = 129;
			Buttons[IDB_ABOUT].bottom = 28;
			Buttons[IDB_ABOUT].normImg = LoadImage(hInst,
				(LPCTSTR)IDB_ABOUTN,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_ABOUT].overImg = LoadImage(hInst,
				(LPCTSTR)IDB_ABOUTO,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_ABOUT].onClick = AboutClick;
			Buttons[IDB_CLOSE].left = 192;
			Buttons[IDB_CLOSE].top = 11;
			Buttons[IDB_CLOSE].right = 209;
			Buttons[IDB_CLOSE].bottom = 28;
			Buttons[IDB_CLOSE].normImg = LoadImage(hInst,
				(LPCTSTR)IDB_CLOSEN,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_CLOSE].overImg = LoadImage(hInst,
				(LPCTSTR)IDB_CLOSEO,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_CLOSE].onClick = CloseClick;
			Buttons[IDB_MINIMIZE].left = 173;
			Buttons[IDB_MINIMIZE].top = 11;
			Buttons[IDB_MINIMIZE].right = 190;
			Buttons[IDB_MINIMIZE].bottom = 28;
			Buttons[IDB_MINIMIZE].normImg = LoadImage(hInst,
				(LPCTSTR)IDB_MINIMIZEN,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_MINIMIZE].overImg = LoadImage(hInst,
				(LPCTSTR)IDB_MINIMIZEO,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_MINIMIZE].onClick = MinimizeClick;
			Buttons[IDB_NEW].left = 11;
			Buttons[IDB_NEW].top = 11;
			Buttons[IDB_NEW].right = 56;
			Buttons[IDB_NEW].bottom = 28;
			Buttons[IDB_NEW].normImg = LoadImage(hInst,
				(LPCTSTR)IDB_NEWN,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_NEW].overImg = LoadImage(hInst,
				(LPCTSTR)IDB_NEWO,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			Buttons[IDB_NEW].onClick = NewClick;
			BgImage = LoadImage(hInst,(LPCTSTR)IDB_FIELD,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			NumbersImage = LoadImage(hInst,(LPCTSTR)IDB_NUMBERS,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR);
			game.New();
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_LBUTTONDOWN:
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);
			for(i=0;i<NBUTTONS;i++)
				if((Buttons[i].left<=xPos)&&(Buttons[i].right>=xPos)&&
					(Buttons[i].top<=yPos)&&(Buttons[i].bottom>=yPos))
				{
					(*Buttons[i].onClick)(hWnd);
					return TRUE;
				}
			if(started)
			{
			 Dir=4;
			 if((xPos>=10)&&(xPos<210)&&(yPos>=50)&&(yPos<250))
			 {
				int x,y;				
				x=(xPos-10)/50;
				y=(yPos-50)/50;
				if(game.x==x)
				{
					if(game.y-y==1)
						Dir=0;
					else if(game.y-y==-1)
						Dir=2;
				}
				else if(game.y==y)
					if(game.x-x==1)
						Dir=3;
					else if(game.x-x==-1)
						Dir=1;
				if(Dir!=4)
				{
				  BOOL result;
				  int oldx=game.x,oldy=game.y;
				  result = game.Move(Dir);
				  RedrawMove(hWnd,oldx,oldy,x,y);					
				  if(result)
					  Victory(hWnd);
				}	
			 return TRUE;
			 }
			}
			DragStartX=xPos;
			DragStartY=yPos;
			dragged=TRUE;
			SetCapture(hWnd);
			break;
		case WM_LBUTTONUP:
			ReleaseCapture();
			dragged=FALSE;
			break;
		case WM_MOUSEMOVE:
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);
			if(dragged)
			{
				POINT p;
				GetCursorPos(&p);
				SetWindowPos(hWnd,HWND_TOP,p.x-DragStartX,p.y-DragStartY,0,0,SWP_NOSIZE);
			}
			overIndex = -1;
			for(i=0;i<NBUTTONS;i++)
				if((Buttons[i].left<=xPos)&&(Buttons[i].right>=xPos)&&
					(Buttons[i].top<=yPos)&&(Buttons[i].bottom>=yPos))
				{
					overIndex=i;
					break;
				}
			if(overIndex!=prevOver)
			{
				hdc=GetDC(hWnd);
				hbmpdc=CreateCompatibleDC(hdc);
				if(prevOver!=-1)
				{
					SelectObject(hbmpdc,Buttons[prevOver].normImg);
					BitBlt(hdc,Buttons[prevOver].left,Buttons[prevOver].top,
						Buttons[prevOver].right-Buttons[prevOver].left,
						Buttons[prevOver].bottom-Buttons[prevOver].top,
						hbmpdc,0,0,SRCCOPY);
				}
				if(overIndex!=-1)
				{
					SelectObject(hbmpdc,Buttons[overIndex].overImg);
					BitBlt(hdc,Buttons[overIndex].left,Buttons[overIndex].top,
						Buttons[overIndex].right-Buttons[overIndex].left,
						Buttons[overIndex].bottom-Buttons[overIndex].top,
						hbmpdc,0,0,SRCCOPY);
				}
				DeleteDC(hbmpdc);
				ReleaseDC(hWnd,hdc);
				prevOver=overIndex;
			}
			Dir=4;
			if(started)
			{
			 if((xPos>=10)&&(xPos<210)&&(yPos>=50)&&(yPos<250))
			 {
				int x,y;				
				x=(xPos-10)/50;
				y=(yPos-50)/50;
				if(game.x==x)
				{
					if(game.y-y==1)
						Dir=0;
					else if(game.y-y==-1)
						Dir=2;
				}
				else if(game.y==y)
					if(game.x-x==1)
						Dir=3;
					else if(game.x-x==-1)
						Dir=1;

			 }
			}
			if(Dir!=prevDir)
				if(Dir!=4)
					SetCursor(LoadCursor(hInst,MAKEINTRESOURCE(cursors[Dir])));
				else
					SetCursor(LoadCursor(NULL,IDC_ARROW));
			prevDir=Dir;
			break;
		case WM_SETCURSOR:
			return TRUE;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			hbmpdc=CreateCompatibleDC(hdc);
			SelectObject(hbmpdc,BgImage);
			BitBlt(hdc,0,0,220,260,hbmpdc,0,0,SRCCOPY);
			for(i=0;i<NBUTTONS;i++)
			{
				SelectObject(hbmpdc,Buttons[i].normImg);
				BitBlt(hdc,Buttons[i].left,Buttons[i].top,
					Buttons[i].right-Buttons[i].left,Buttons[i].bottom-Buttons[i].top,
					hbmpdc,0,0,SRCCOPY);
			}
			if(started)
			{
			 rt.left = 40;
			 rt.right = 180;
			 rt.top = 29;
			 rt.bottom = 50;
			 wsprintf(szTime,"Time elapsed - %d",eltime);
			 SetBkColor(hdc,RGB(164,110,32));
   			 DrawText(hdc,szTime,strlen(szTime),&rt,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
			 SelectObject(hbmpdc,NumbersImage);
			 for(i=0;i<4;i++)
				for(j=0;j<4;j++)
				{
					rt.left=10+i*50;
					rt.right=rt.left+50;
					rt.top=50+j*50;
					rt.bottom=rt.top+50;
					if(game.cells[i][j]!=0)
					{
						BitBlt(hdc,rt.left,rt.top,50,50,hbmpdc,
							numbers[game.cells[i][j]][0],
							numbers[game.cells[i][j]][1],SRCCOPY);
					}
				}
			}
			DeleteDC(hbmpdc);
			EndPaint(hWnd, &ps);
			break;
		case WM_TIMER:
			hdc=GetDC(hWnd);
			rt.left = 40;
			rt.right = 180;
			rt.top = 29;
			rt.bottom = 50;
			eltime+=1;
			wsprintf(szTime,"Time elapsed - %d",eltime);
			SetBkColor(hdc,RGB(164,110,32));
			DrawText(hdc,szTime,strlen(szTime),&rt,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
			ReleaseDC(hWnd,hdc);
			break;
		case WM_KEYDOWN:
			nVirtKey = (int) wParam;
			if(nVirtKey==VK_ESCAPE)
				DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			//kill all stuff
			for(i=0;i<NBUTTONS;i++)
			{
				DeleteObject(Buttons[i].normImg);
				DeleteObject(Buttons[i].overImg);
			}
			DeleteObject(NumbersImage);
			DeleteObject(BgImage);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			CenterWindow(hDlg);
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

LRESULT CALLBACK Results(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR szN[30];
	TCHAR szBuf1[500]="",szBuf2[500]="";
	int i;
	HWND hDlgItem;

	switch (message)
	{
		case WM_INITDIALOG:
				for(i=0;i<10;i++)
				{
					strcat(szBuf1,records.data[i].Name);
					strcat(szBuf1,"\n");
					wsprintf(szN,"%d\n",records.data[i].Result);
					strcat(szBuf2,szN);
				}
				hDlgItem=GetDlgItem(hDlg,IDC_NAMES);
				SetWindowText(hDlgItem,szBuf1);
				hDlgItem=GetDlgItem(hDlg,IDC_SCORES);
				SetWindowText(hDlgItem,szBuf2);
				CenterWindow(hDlg);
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

void AboutClick(HWND hWnd)
{
	DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
}

void ResultsClick(HWND hWnd)
{
	DialogBox(hInst, (LPCTSTR)IDD_RESULTS, hWnd, (DLGPROC)Results);
}

void CloseClick(HWND hWnd)
{
	DestroyWindow(hWnd);
}

void MinimizeClick(HWND hWnd)
{
	ShowWindow(hWnd,SW_MINIMIZE);
}

void NewClick(HWND hWnd)
{
	RECT rt;
	rt.left = 10;
	rt.right = 210;
	rt.top = 29;
	rt.bottom = 250;
	game.New();
	started=TRUE;
	eltime=0;
	SetTimer(hWnd,0,1000,NULL);
	InvalidateRect(hWnd,&rt,FALSE);
}

void Victory(HWND hWnd)
{

	KillTimer(hWnd,0);
	result=eltime;
	eltime=0;
	started=FALSE;
	InvalidateRect(hWnd,NULL,FALSE);
	DialogBox(hInst, (LPCTSTR)IDD_VICTORY, hWnd, (DLGPROC)About);
	if(eltime<records.data[9].Result)
		DialogBox(hInst,(LPCTSTR)IDD_TOP, hWnd, (DLGPROC)Top);
}

LRESULT CALLBACK Top(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR szName[30];
	HWND hDlgItem;

	switch (message)
	{
		case WM_INITDIALOG:
				hDlgItem=GetDlgItem(hDlg,IDC_NAME);
				SetWindowText(hDlgItem,szLastName);
				CenterWindow(hDlg);
				SetFocus(hDlgItem);
				return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					hDlgItem=GetDlgItem(hDlg,IDC_NAME);
					if(GetWindowText(hDlgItem,szName,30)>0)
					{
						strcpy(szLastName,szName);
						records.Insert(szName,result);
						EndDialog(hDlg, LOWORD(wParam));
						return TRUE;
					}
					else
						MessageBox(hDlg,"You haven't entered your name!","15",MB_OK);
					return TRUE;
				case IDCANCEL:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
			}
			break;
	}
    return FALSE;
}

void RedrawMove(HWND hWnd,int filledx,int filledy,int emptyx,int emptyy)
{
	HDC hdc,hbmpdc;
	hdc=GetDC(hWnd);
	hbmpdc=CreateCompatibleDC(hdc);
	SelectObject(hbmpdc,BgImage);
	BitBlt(hdc,10+emptyx*50,50+emptyy*50,50,50,hbmpdc,10+emptyx*50,50+emptyy*50,SRCCOPY);
	SelectObject(hbmpdc,NumbersImage);
	BitBlt(hdc,10+filledx*50,50+filledy*50,50,50,hbmpdc,
		numbers[game.cells[filledx][filledy]][0],
		numbers[game.cells[filledx][filledy]][1],SRCCOPY);
	DeleteDC(hbmpdc);
	ReleaseDC(hWnd,hdc);
}

void CenterWindow(HWND hWnd)
{
	HWND hParent;
	RECT rtParent,rtWindow;
	int x,y;
	if((hParent=GetParent(hWnd))==NULL)
		hParent=GetDesktopWindow();
	GetWindowRect(hWnd,&rtWindow);
	GetWindowRect(hParent,&rtParent);
	x=(rtParent.left+rtParent.right-rtWindow.right+rtWindow.left)/2;
	y=(rtParent.top+rtParent.bottom-rtWindow.bottom+rtWindow.top)/2;
	SetWindowPos(hWnd,HWND_TOP,x,y,0,0,SWP_NOSIZE);
}